program clock;

{$MODE OBJFPC}
{$LONGSTRINGS ON}
{$SMARTLINK ON}
{$APPTYPE GUI}

uses windows,sysutils,classes;

type
    TGt  = class(TThread)
    public
         procedure AfterConstruction; override;
         procedure Execute; override;
    end;

const
    WCNClock = 'Clock';
    colr_black : dword = 0;
    colr_white : dword = $FFFFFF;
    clock_width = 790;
    clock_height = 420;
    clock_top = 40;
    clock_left = 0;
    mon_name : array [1..12] of string =('',
    '', '', '', '', '', '', '',
    '', '', '', '');
    wdn : array[1..7] of string = ('','','','','','','');

var
    WCEClock: PWndClassEx;
    apphinstance, hClock : THandle;
    hf_clock, region : THandle;
    hb_black : THandle;
    Msg : TMsg;
    gt  : TThread;
    year : LongInt;
    month, day, hour, minute : byte;

function inttofix2str(i : integer) : string;
begin result := inttostr(i);if 10 > i then result := '0' + result; end;

function Weekday(year, month, day: LongInt): byte;
begin
    if month < 3 then
    begin
	year := year - 1;
	month := month + 10;
    end
    else
	month := month - 2;
    Weekday := (day + 31 * month div 12 + year + year div 4 - year div 100 + year div 400) mod 7;
end;
function WeekdayRu(year, month, day: LongInt) : byte;
begin
result := Weekday(year, month, day);
if result = 0 then Exit(7);
end;

function WPClock (
         Wnd : HWnd;
         Msg : cardinal;
         wParam, lParam : longint
         ) : longint; stdcall;
  var
    p         : TPaintStruct;
    s         : string;
    BkColor   : Dword;
    DC        : THandle;
    r         : TRect;
    BColor    : THandle;
 begin
 result := 0;
 case Msg of
      WM_PAINT : begin
 DC := GetWindowDC(wnd); BeginPaint(wnd, p);
 BkColor := colr_black;
 BColor := hb_black;
 r.Left := 0; r.Right := clock_width; r.Top := 0; r.Bottom := clock_height;
 FillRect(DC, r, BColor);
 SelectObject(DC, hf_clock);
    SetTextColor(DC, colr_white);
 SetBkColor(dc, BkColor);
 SetTextAlign(dc, TA_CENTER);
s := IntToStr(hour) + ':' + IntToFix2Str(minute);
 TextOut(DC, clock_width div 2 - 1, 0, PCHar(s), Length(s));
s := mon_name[month] + ' (' + IntToStr(month) + ')';
 TextOut(DC, clock_width div 2 - 1, 100, PCHar(s), Length(s));
s := wdn[WeekdayRu(year, month, day)] + ' ' + IntToStr(day);
 TextOut(DC, clock_width div 2 - 1, 200, PCHar(s), Length(s));
s := IntToStr(year);
 TextOut(DC, clock_width div 2 - 1, 300, PCHar(s), Length(s));
 ReleaseDC(wnd, DC);
      EndPaint(wnd, p);
      end;
      WM_NCHITTEST: begin
          result := DefWindowProc(wnd, msg, wparam, lparam);
          if Result = HTCLIENT then Result := HTCAPTION;
      end;
      WM_NCLBUTTONDBLCLK: halt;
      else result := DefWindowProc(Wnd, Msg, wParam, lParam)
      end
end;

procedure TGt.AfterConstruction;
begin
  inherited AfterConstruction;
  FreeOnTerminate := True;
end;

procedure TGt.Execute;
  var t : TSystemTime;
begin
SetThreadPriority(Handle, THREAD_PRIORITY_TIME_CRITICAL);
while true do begin
 GetLocalTime(t);
 if (year <> t.wYear) or (month <> t.wMonth) or (day <> t.wDay) or (hour <> t.wHour) or (minute <> t.wMinute) then begin
year := t.wYear; month := t.wMonth; day := t.wDay;
hour := t.wHour; minute := t.wMinute;
//BringWindowToTop(hClock);
SendMessage(hClock, WM_PAINT, 0, 0);
 end;
sleep(3000);
end;
end;

begin
hf_clock := CreateFont(-100, 0, 0, 0, 800, Integer(false),
                        Integer(false), Integer(false),
                        DEFAULT_CHARSET, OUT_DEFAULT_PRECIS,
                        CLIP_DEFAULT_PRECIS, PROOF_QUALITY,
                        DEFAULT_PITCH or FF_MODERN,
                        'Courier New');
hb_black := CreateSolidBrush(colr_black);
apphinstance := GetModuleHandle(nil);

WCEClock := new(PWndClassEx);
  with WCEClock^ do begin
  style           := CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS or CS_OWNDC;
  lpfnWndProc     := @WPClock;
  cbClsExtra      := 0;
  cbWndExtra      := 0;
  hInstance       := apphinstance;
  hIcon           := LoadIcon(0, IDI_APPLICATION);
  hCursor         := LoadCursor(0, IDC_ARROW);
  hbrBackground   := hb_black;
  lpszMenuName    := nil;
  lpszClassName   := WCNClock;
  hIconSm         := 0;
  cbSize          := sizeof(TWndClassEx);
  end;
RegisterClassEx(WCEClock^); dispose(WCEClock);
hClock  := CreateWindowEx (
           WS_EX_TOPMOST or WS_EX_TOOLWINDOW,
           WCNClock,
           'Clock',
           WS_VISIBLE,
           clock_left, clock_top,
           clock_width, clock_height,
           0,
           0,
           appHInstance,
           nil
           );
SetWindowLong(hClock, GWL_STYLE, GetWindowLong(hClock, GWL_STYLE) and
                   (Not (WS_CAPTION or WS_BORDER)) );
 region := CreateRoundRectRgn(0,0, clock_width, clock_height - 1, 22, 22);
 SetWindowRgn(hclock, region, True);
 SetWindowPos(hclock, hclock, 0, 0, clock_width, clock_height,
 SWP_NOMOVE or SWP_NOZORDER or SWP_FRAMECHANGED or SWP_DRAWFRAME or SWP_NOACTIVATE);
ShowWindow(hClock, SW_SHOWNORMAL);

gt := TGt.Create(True);
gt.Start;

while GetMessage (Msg, 0, 0, 0) do
      begin
      TranslateMessage(Msg);
      DispatchMessage(Msg)
      end;
end.